

%% after running any dynare mod file using a third-order simulation, this
%% will replicate the simulations created by dynare. 
DR=oo_.dr;

% DR.g_1=[oo_.dr.ghx oo_.dr.ghu];
% DR.g_2=zeros(6,28);
% DR.g_3=zeros(6,84);

nstate=size(DR.g_1,2);

%% perm2 and perm3 are matrices for the second and third-order terms in the
%% decision rules. Each column is for a different permutation, i.e. 
%% x(i)*x(j)*x(k), where x is the state vector. the numbers in the 
%% columns are the indexes in the state vector.
perm3=[];
for i=1:nstate
    for j=1:nstate
        for k=1:nstate
            if k>=j & j>=i
                perm3=[perm3,[i,j,k]'];
            end
        end
    end
end

perm2=[];
for i=1:nstate
    for j=1:nstate
            if j>=i
                perm2=[perm2,[i,j]'];
            end
    end
end

% consider the quadratic terms. the decision rules only include the
% coefficient for x(i)*x(j) once, there isn't a second value somewhere for
% x(j)*x(i). So terms involving x(i)*x(j) need to be multiplied by 2 (but
% x(i)*x(i) doesn't). mult3 gets the multipliers for the third-order
% approximation.
mult3=3*sum(perm3(2:end,:)~=perm3(1:end-1,:)); mult3=max(mult3,1);
mult2=2*(perm2(2,:)~=perm2(1,:)); mult2=max(mult2,1);

% oo_.dr.order_var reorders the variables from how they're listed in the
% simulation to how they're ordered in the decision rule. See the
% documentation for an explanation.
state_num=oo_.dr.order_var(oo_.dr.nstatic+1:oo_.dr.nstatic+oo_.dr.npred);
state1=bsxfun(@plus,oo_.endo_simul,-oo_.steady_state);
state=state1(state_num,:)'; NE=size(state,2);

NN=length(oo_.endo_simul);

simul_alt=0*oo_.endo_simul';
simul_alt(1,:)=oo_.endo_simul(:,1)';

%% this matches the entire simulation that dynare produces. 
tic;
next=state(1,:);
DR=oo_.dr;
DR.g_0=DR.g_0+DR.ys(DR.order_var);
nstate=length(state_num);
nerr=size(DR.g_1,2)-nstate;

eps=sqrt(2)*[-2.350604974
-1.335849074
-0.436077412
0.436077412
1.335849074
2.350604974
];

ww=[2.555784E-03
8.861575E-02
4.088285E-01
4.088285E-01
8.861575E-02
2.555784E-03
];
WW=bsxfun(@times,ww,ww');

epsz=permute(eps,[3,4,1,2]);
epsa=permute(eps,[3,4,2,1]);

wwz=permute(ww,[3,4,1,2]);
wwa=permute(ww,[3,4,2,1]);
    state_num=oo_.dr.order_var(oo_.dr.nstatic+1:oo_.dr.nstatic+oo_.dr.npred);
    state_true=oo_.endo_simul;
    state1=bsxfun(@plus,oo_.endo_simul,-oo_.steady_state);
    state1=state1(state_num,:)';

    holder=zeros(length(eps),length(eps),6);
    EE=zeros(NN,1);
    
    
for i=2:NN
    if floor(i/100)==i/100; disp(i); end;
    
    for ea=1:length(eps)
        for ez=1:length(eps)
            next=state1(i,:);

            stateC=[next eps([ez ea])'];
            next=(mult3.*prod(stateC(perm3)))*DR.g_3' +...
            (mult2.*prod(stateC(perm2)))*DR.g_2' +...
            stateC*DR.g_1' + ...
            DR.g_0';
            
            next=next(oo_.dr.inv_order_var);
            holder(ea,ez,:)=next;
        end
    end
    

    
    c_next=holder(:,:,1);
    rw_next=holder(:,:,4);
    a_next=holder(:,:,6);
    
    c_now=oo_.endo_simul(1,i);
    rw_now=oo_.endo_simul(4,i);
    a_now=oo_.endo_simul(6,i);
    k_now=oo_.endo_simul(2,i);
    z_now=oo_.endo_simul(3,i);
    
    rk = gamma*exp((gamma-1)*(k_now - a_next+a_now))+1-delta;
    SDF = exp(z_now*(-beta-rho*(c_next+a_next-c_now-a_now))...
                +(z_now-1)*rw_next);
            
    EE(i)=sum(sum(SDF.*rk.*WW));
    
end


toc

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% to get first-order Euler eqn errors
%% only run it after doing dynare in the first order



%% after running any dynare mod file using a third-order simulation, this
%% will replicate the simulations created by dynare. 
DR=oo_.dr;

nstate=size(DR.ghx,2);
state_num=oo_.dr.order_var(oo_.dr.nstatic+1:oo_.dr.nstatic+oo_.dr.npred);
state1=bsxfun(@plus,oo_.endo_simul,-oo_.steady_state);
state=state1(state_num,:)'; NE=size(state,2);

NN=length(oo_.endo_simul);

simul_alt=0*oo_.endo_simul';
simul_alt(1,:)=oo_.endo_simul(:,1)';

%% this matches the entire simulation that dynare produces. 
tic;
next=state(1,:);
DR=oo_.dr;

nstate=length(state_num);
nerr=size(DR.ghu,2);

eps=sqrt(2)*[-2.350604974
-1.335849074
-0.436077412
0.436077412
1.335849074
2.350604974
];

ww=[2.555784E-03
8.861575E-02
4.088285E-01
4.088285E-01
8.861575E-02
2.555784E-03
];
WW=bsxfun(@times,ww,ww');

epsz=permute(eps,[3,4,1,2]);
epsa=permute(eps,[3,4,2,1]);

wwz=permute(ww,[3,4,1,2]);
wwa=permute(ww,[3,4,2,1]);
    state_num=oo_.dr.order_var(oo_.dr.nstatic+1:oo_.dr.nstatic+oo_.dr.npred);
    state_true=oo_.endo_simul;
    state1=bsxfun(@plus,oo_.endo_simul,-oo_.steady_state);
    state1=state1(state_num,:)';

    holder=zeros(length(eps),length(eps),6);
    EE=zeros(NN,1);
    
    
for i=2:NN
    if floor(i/100)==i/100; disp(i); end;
    for ea=1:length(eps)
        for ez=1:length(eps)
            next=state1(i,:);

            stateC=[next eps([ez ea])'];
            next=next*DR.ghx' + ...
                    eps([ez ea])'*DR.ghu'+...
            DR.ys(DR.order_var)';
            
            next=next(oo_.dr.inv_order_var);
            holder(ea,ez,:)=next;
        end
    end


    
    c_next=holder(:,:,1);
    rw_next=holder(:,:,4);
    a_next=holder(:,:,6);
    
    c_now=oo_.endo_simul(1,i);
    rw_now=oo_.endo_simul(4,i);
    a_now=oo_.endo_simul(6,i);
    k_now=oo_.endo_simul(2,i);
    z_now=oo_.endo_simul(3,i);
    
    rk = gamma*exp((gamma-1)*(k_now - a_next+a_now))+1-delta;
    SDF = exp(z_now*(-beta-rho*(c_next+a_next-c_now-a_now))...
                +(z_now-1)*rw_next);
            
    EE(i)=sum(sum(SDF.*rk.*WW));
    
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% to get second-order Euler eqn errors
%% only run it after doing dynare in the first order

%% after running any dynare mod file using a third-order simulation, this
%% will replicate the simulations created by dynare. 
DR=oo_.dr;

nstate=size(DR.ghx,2);
state_num=oo_.dr.order_var(oo_.dr.nstatic+1:oo_.dr.nstatic+oo_.dr.npred);
state1=bsxfun(@plus,oo_.endo_simul,-oo_.steady_state);
state=state1(state_num,:)'; NE=size(state,2);

NN=length(oo_.endo_simul);

simul_alt=0*oo_.endo_simul';
simul_alt(1,:)=oo_.endo_simul(:,1)';

%% this matches the entire simulation that dynare produces. 
tic;
next=state(1,:);
DR=oo_.dr;

nstate=length(state_num);
nerr=size(DR.ghu,2);

eps=sqrt(2)*[-2.350604974
-1.335849074
-0.436077412
0.436077412
1.335849074
2.350604974
];

ww=[2.555784E-03
8.861575E-02
4.088285E-01
4.088285E-01
8.861575E-02
2.555784E-03
];
WW=bsxfun(@times,ww,ww');

epsz=permute(eps,[3,4,1,2]);
epsa=permute(eps,[3,4,2,1]);

wwz=permute(ww,[3,4,1,2]);
wwa=permute(ww,[3,4,2,1]);
    state_num=oo_.dr.order_var(oo_.dr.nstatic+1:oo_.dr.nstatic+oo_.dr.npred);
    state_true=oo_.endo_simul;
    state1=bsxfun(@plus,oo_.endo_simul,-oo_.steady_state);
    state1=state1(state_num,:)';

    holder=zeros(length(eps),length(eps),6);
    EE=zeros(NN,1);
    
    
for i=2:NN
    if floor(i/100)==i/100; disp(i); end;
    for ea=1:length(eps)
        for ez=1:length(eps)
            next=state1(i,:);

            stateC=[next eps([ez ea])'];

            next=DR.ys(DR.order_var)' + ...
                .5*DR.ghs2' + ...
                next*DR.ghx' + ...
                eps([ez ea])'*DR.ghu' + ...
                .5*kron(next,next)*DR.ghxx' + ...
                .5*kron(oo_.exo_simul(i,:),eps([ez ea])')*DR.ghuu' + ...
                kron(next,eps([ez ea])')*DR.ghxu';
            
            next=next(oo_.dr.inv_order_var);
            holder(ea,ez,:)=next;
        end
    end


    
    c_next=holder(:,:,1);
    rw_next=holder(:,:,4);
    a_next=holder(:,:,6);
    
    c_now=oo_.endo_simul(1,i);
    rw_now=oo_.endo_simul(4,i);
    a_now=oo_.endo_simul(6,i);
    k_now=oo_.endo_simul(2,i);
    z_now=oo_.endo_simul(3,i);
    
    rk = gamma*exp((gamma-1)*(k_now - a_next+a_now))+1-delta;
    SDF = exp(z_now*(-beta-rho*(c_next+a_next-c_now-a_now))...
                +(z_now-1)*rw_next);
            
    EE(i)=sum(sum(SDF.*rk.*WW));
    
end
